<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>polylib: pp.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.6 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
<h1>pp.c</h1><a href="pp_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00002"></a>00002 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00005"></a>00005 
<a name="l00006"></a><a class="code" href="pp_8c.html#59799636dce6e7dfa2ce20c48147fa6b">00006</a> <span class="preprocessor">#define WS 0</span>
<a name="l00007"></a>00007 <span class="preprocessor"></span>
<a name="l00008"></a><a class="code" href="pp_8c.html#e66f6b31b5ad750f1fe042a706a4e3d4">00008</a> <span class="keywordtype">int</span> <a class="code" href="c2p_8c.html#e66f6b31b5ad750f1fe042a706a4e3d4">main</a>() {
<a name="l00009"></a>00009         
<a name="l00010"></a>00010   <a class="code" href="structmatrix.html">Matrix</a> *a, *b;
<a name="l00011"></a>00011   <a class="code" href="structpolyhedron.html">Polyhedron</a> *A, *B;
<a name="l00012"></a>00012   <a class="code" href="struct__Param__Polyhedron.html">Param_Polyhedron</a> *PA;
<a name="l00013"></a>00013   <a class="code" href="struct__Param__Domain.html">Param_Domain</a> *P;
<a name="l00014"></a>00014   <a class="code" href="struct__Param__Vertex.html">Param_Vertices</a> *V;
<a name="l00015"></a>00015   <span class="keywordtype">int</span> <a class="code" href="polyparam_8c.html#135433bf69beff8673f093340cbe29be">nbPV</a>, i, j;
<a name="l00016"></a>00016   <span class="keyword">const</span> <span class="keywordtype">char</span> **param_name;
<a name="l00017"></a>00017   
<a name="l00018"></a>00018   a = <a class="code" href="matrix_8c.html#3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00019"></a>00019   <span class="keywordflow">if</span>(!a || a-&gt;<a class="code" href="structmatrix.html#68858fd3b57684ef38bdfce13c65d182">NbColumns</a> == 0) {
<a name="l00020"></a>00020     fprintf(stderr,<span class="stringliteral">"Input error: empty matrix\n"</span>);
<a name="l00021"></a>00021     exit(0);
<a name="l00022"></a>00022   }
<a name="l00023"></a>00023   A = <a class="code" href="polyhedron_8c.html#efb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(a, <a class="code" href="ext__ehrhart_8c.html#59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00024"></a>00024   <a class="code" href="matrix_8c.html#fcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(a);
<a name="l00025"></a>00025   b = <a class="code" href="matrix_8c.html#3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00026"></a>00026   
<a name="l00027"></a>00027   <span class="keywordflow">if</span>(!b || b-&gt;<a class="code" href="structmatrix.html#68858fd3b57684ef38bdfce13c65d182">NbColumns</a> == 0) {
<a name="l00028"></a>00028     fprintf(stderr, <span class="stringliteral">"Input error: empty matrix\n"</span>);
<a name="l00029"></a>00029     exit(0);
<a name="l00030"></a>00030   }
<a name="l00031"></a>00031   B = <a class="code" href="polyhedron_8c.html#efb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(b, <a class="code" href="ext__ehrhart_8c.html#59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00032"></a>00032   <a class="code" href="matrix_8c.html#fcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(b);
<a name="l00033"></a>00033   
<a name="l00034"></a>00034   <span class="comment">/* Read the name of the parameters */</span>
<a name="l00035"></a>00035   param_name = <a class="code" href="param_8c.html#c5f556f34173ebc8815247ee7f4e2a0b">Read_ParamNames</a>(stdin, B-&gt;<a class="code" href="structpolyhedron.html#2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>);
<a name="l00036"></a>00036   PA = <a class="code" href="polyparam_8c.html#57cedd532b6fbd7a8d7549758eabaf94">Polyhedron2Param_Domain</a>(A,B,<a class="code" href="ext__ehrhart_8c.html#59799636dce6e7dfa2ce20c48147fa6b">WS</a>);
<a name="l00037"></a>00037   <span class="keywordflow">if</span>(!PA || PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#23eb52a684bb212c4cf1fbcbd9db066c">D</a>==NULL) {
<a name="l00038"></a>00038     printf(<span class="stringliteral">"---------------------------------------\n"</span>);
<a name="l00039"></a>00039     printf(<span class="stringliteral">"Empty polyhedron\n"</span>);
<a name="l00040"></a>00040     <span class="keywordflow">return</span> 0;
<a name="l00041"></a>00041   }
<a name="l00042"></a>00042   nbPV = PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#baa0a017c7bef81b5ed9f6d2fd3f6f58">nbV</a>;
<a name="l00043"></a>00043   <a class="code" href="polyhedron_8c.html#e6d0a7daf8e801a777fc8e93d8cfe43a">Domain_Free</a>(A);
<a name="l00044"></a>00044   <a class="code" href="polyhedron_8c.html#e6d0a7daf8e801a777fc8e93d8cfe43a">Domain_Free</a>(B);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#16ad614d15c6e81c0041e877b623c72d">NbRows</a> &gt; 0) {
<a name="l00047"></a>00047     printf( <span class="stringliteral">"---------------------------------------\n"</span> );
<a name="l00048"></a>00048     printf( <span class="stringliteral">"Overall rays :\n"</span>);
<a name="l00049"></a>00049     <span class="keywordflow">for</span> (i = 0; i &lt; PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#16ad614d15c6e81c0041e877b623c72d">NbRows</a>; i++) {
<a name="l00050"></a>00050       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#827532f2140ae2aa96e46baebae09723">value_zero_p</a>(PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][0]))
<a name="l00051"></a>00051         printf(<span class="stringliteral">"Line:   ["</span>);
<a name="l00052"></a>00052       <span class="keywordflow">else</span>
<a name="l00053"></a>00053         printf(<span class="stringliteral">"Ray:    ["</span>);
<a name="l00054"></a>00054       <span class="keywordflow">for</span> (j = 1; j &lt; PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-1; j++) {
<a name="l00055"></a>00055         <a class="code" href="source_2arith_2arithmetique_8h.html#d34605b56b571830b928b50a74d618b7">value_print</a>(stdout,<a class="code" href="types_8h.html#e6f16bcd4a42ba51cbb003e3d1e1cde6">P_VALUE_FMT</a>,PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>-&gt;<a class="code" href="structmatrix.html#2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j]);
<a name="l00056"></a>00056       }
<a name="l00057"></a>00057       printf(<span class="stringliteral">" ]\n"</span>);
<a name="l00058"></a>00058     }
<a name="l00059"></a>00059   }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">/*****************************/</span>
<a name="l00062"></a>00062   <span class="comment">/* Scan the validity domains */</span>
<a name="l00063"></a>00063   <span class="keywordflow">for</span>(P=PA-&gt;<a class="code" href="struct__Param__Polyhedron.html#23eb52a684bb212c4cf1fbcbd9db066c">D</a>;P;P=P-&gt;<a class="code" href="struct__Param__Domain.html#5e0de697b290be8c04aeb01af780c557">next</a>) {
<a name="l00064"></a>00064     
<a name="l00065"></a>00065     <span class="comment">/* prints current val. dom. */</span>
<a name="l00066"></a>00066     printf( <span class="stringliteral">"---------------------------------------\n"</span> );
<a name="l00067"></a>00067     printf( <span class="stringliteral">"Domain :\n"</span>);
<a name="l00068"></a>00068     <a class="code" href="polyparam_8c.html#fa315bc856959f9a781359f69b74d7a4">Print_Domain</a>( stdout, P-&gt;<a class="code" href="struct__Param__Domain.html#ac7b708b50ebee4352fddebed2eaba7c">Domain</a>, param_name );
<a name="l00069"></a>00069     
<a name="l00070"></a>00070     <span class="comment">/* scan the vertices */</span>
<a name="l00071"></a>00071     printf( <span class="stringliteral">"Vertices :\n"</span>);
<a name="l00072"></a>00072     <a class="code" href="types_8h.html#ea9236e3c02c25e1cb628684409630fc">FORALL_PVertex_in_ParamPolyhedron</a>(V,P,PA) {
<a name="l00073"></a>00073         
<a name="l00074"></a>00074       <span class="comment">/* prints each vertex */</span>
<a name="l00075"></a>00075       <a class="code" href="polyparam_8c.html#ed63fd8f223a4776c442b144edb03fae">Print_Vertex</a>( stdout, V-&gt;<a class="code" href="struct__Param__Vertex.html#d61ebc6810df483f7b0e25fea5c6cdf1">Vertex</a>, param_name );
<a name="l00076"></a>00076       printf( <span class="stringliteral">"\n"</span> );
<a name="l00077"></a>00077     }
<a name="l00078"></a>00078     <a class="code" href="types_8h.html#670b1ea03d880e2595bddca5745df8ec">END_FORALL_PVertex_in_ParamPolyhedron</a>;
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080   <span class="comment">/*****************************/</span>
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <a class="code" href="polyparam_8c.html#499deb4842822ae8ae58ed1fdf079c88">Param_Polyhedron_Free</a>( PA );
<a name="l00083"></a>00083   free(param_name);
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="keywordflow">return</span> 0;
<a name="l00086"></a>00086 } <span class="comment">/* main */</span> 
<a name="l00087"></a>00087 
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 15 18:34:00 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.6 </small></address>
</body>
</html>
